clear;

case_d = 'd0510';
case_pol = 'Planner';

file{1} = ['../Mat/Baseline_pi4med_C1L1B4_',case_d,'_025_', case_pol, '.mat'];
file{2} = ['../Mat/Baseline_pi4med_C1L1B4_',case_d,'_05_', case_pol, '.mat'];
file{3} = ['../Mat/Baseline_pi4med_C1L1B4_',case_d,'_075_', case_pol, '.mat'];


ia=3;ib=4;fsize=12;
horz=156;
time=0:1:horz-1;

f=figure;

for i = 1:length(file)
    load(file{i},'HH','policylength','beta','z','zstar','kappa','alpha','sigma','I0','Istar0','pop0','popstar0','pi1','pi2','pi3','pi4','pir','pid','pid_accel','phi','Uiss','Urss','Udeath','muh','muf','muhstar','mufstar','delta_muin','delta_nuin','n_vec');
    
    policylength = HH;
    [err_0,ls_0,lsstar_0,li_0,listar_0,lr_0,lrstar_0,xs_0,xsstar_0,xi_0,xistar_0,xr_0,xrstar_0,chs_0,cfs_0,chsstar_0,cfsstar_0,chi_0,cfi_0,chistar_0,cfistar_0,chr_0,cfr_0,chrstar_0,cfrstar_0,...
        ph_0,pfstar_0,S_0,Sstar_0,I_0,Istar_0,R_0,Rstar_0,T_0,Tstar_0,aggC_0,aggCstar_0,aggL_0,aggLstar_0,g_0,gstar_0,aggU_0,aggUstar_0] = ...
        getErr(n_vec,...
        HH,policylength,beta,z,zstar,kappa,...
        alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
        pi2,pi3,pi4,pir,pid,pid_accel,phi,...
        Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);
    
    muh_0 = muh;
    muf_0 = muf;
    muhstar_0 = muhstar;
    mufstar_0 = mufstar;
    

    spending_0 = (chs_0.*S_0+chi_0.*I_0+chr_0.*R_0)./(cfs_0.*S_0+cfi_0.*I_0+cfr_0.*R_0);
    spendingstar_0 = (cfsstar_0.*Sstar_0+cfistar_0.*Istar_0+cfrstar_0.*Rstar_0)./(chsstar_0.*Sstar_0+chistar_0.*Istar_0+chrstar_0.*Rstar_0);

    
    ur_0=log(xr_0)-kappa/2*lr_0.^2;
    urstar_0=log(xrstar_0)-kappa/2*lrstar_0.^2;
    ui_0=log(xi_0)-kappa/2*li_0.^2;
    uistar_0=log(xistar_0)-kappa/2*listar_0.^2;
    us_0=log(xs_0)-kappa/2*ls_0.^2;
    usstar_0=log(xsstar_0)-kappa/2*lsstar_0.^2;
    aggu_0=S_0.*us_0 + I_0.*ui_0 + R_0.*ur_0;
    aggustar_0=Sstar_0.*usstar_0 + Istar_0.*uistar_0 + Rstar_0.*urstar_0;
    
    
    subplot(ia,ib,1)
    hold on;
    plot(time,I_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,2)
    hold on;
    h1 = plot(time,1-S_0(1:horz)-I_0(1:horz)-R_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,3)
    hold on;
    plot(time,Istar_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,4)
    hold on;
    h2 = plot(time,1-Sstar_0(1:horz)-Istar_0(1:horz)-Rstar_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,5)
    hold on;
    plot(time,muh_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,6)
    hold on;
    plot(time,muf_0(1:horz)-muh_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,7)
    hold on;
    plot(time,mufstar_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,8)
    hold on;
    plot(time,muhstar_0(1:horz)-mufstar_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,9)
    hold on;
    plot(time,muf_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,10)
    hold on;
    plot(time,muhstar_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,11)
    hold on;
    plot(time,ph_0(1:horz)./pfstar_0(1:horz),'LineWidth',2);
    
    subplot(ia,ib,12)
    hold on;
    plot(time,0,'LineWidth',2);
    
end

subplot(ia,ib,1)
box off;
title('Country A Infected, $I^A$','FontSize',fsize,'interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,2)
box off;
title('Country A Death, $D^A$','FontSize',fsize,'interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize,'interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h1, 'axes');
ax.YAxis.Exponent = 0;

subplot(ia,ib,3)
box off;
title('Country B Infected, $I^B$','FontSize',fsize,'interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,4)
box off;
title('Country B Death, $D^B$','FontSize',fsize,'interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize,'interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h2, 'axes');
ax.YAxis.Exponent = 0;

subplot(ia,ib,5)
box off;
title('Country A Containment Tax $\mu^A$','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,.7]);

subplot(ia,ib,6)
box off;
title('Country A Tariff $\nu^A$','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,7)
box off;
title('Country B Containment Tax $\mu^B$','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,.7]);

subplot(ia,ib,8)
box off;
title('Country B Tariff $\nu^B$','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,9)
box off;
title('Country A $\mu^A+\nu^A$','FontSize',fsize,'interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,10)
box off;
title('Country B $\mu^B+\nu^B$','FontSize',fsize,'interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,11)
box off;
title('Terms of Trade $p^A/p^B$','FontSize',fsize,'interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

% subplot(ia,ib,10)
% box off;
% title('A Cons. Ratio $c^A_A/c^A_B$','FontSize',fsize,'interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% 
% subplot(ia,ib,11)
% box off;
% title('B Cons. Ratio $c^B_B/c^B_A$','FontSize',fsize,'interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);

subplot(ia,ib,12)
box off;
legend('\zeta=0.025','\zeta=0.050','\zeta=0.075', 'Location', 'northeast');
set(gca,'FontSize',fsize);

orient landscape

f.PaperSize = [8 6]*1.5;
print(['../Figures/Compare_Congestion_',case_d,'_',case_pol,'.pdf'],'-dpdf','-fillpage')

clear;

close all;