clear;
job_name='Baseline_pi4med_C1L1B4_d0510_05';
close all;

spec_label = job_name;

file_baseline = strcat('../Mat/', job_name, '_Benchmark.mat');
file_sp = strcat('../Mat/', job_name, '_Planner.mat');
file_nash = strcat('../Mat/', job_name, '_Nash.mat');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% benchmark
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load(file_baseline);
policylength = HH;


[n_vec,fval,exitflag]=fsolve(@getErr,n_vec,opts_fsolve,...
    HH,policylength,beta,z,zstar,kappa,...
    alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
    pi2,pi3,pi4,pir,pid,pid_accel,phi,...
    Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);


[err_0,ls_0,lsstar_0,li_0,listar_0,lr_0,lrstar_0,xs_0,xsstar_0,...
    xi_0,xistar_0,xr_0,xrstar_0,chs_0,cfs_0,chsstar_0,cfsstar_0,...
    chi_0,cfi_0,chistar_0,cfistar_0,chr_0,cfr_0,chrstar_0,cfrstar_0,...
    ph_0,pfstar_0,S_0,Sstar_0,I_0,Istar_0,R_0,Rstar_0,T_0,Tstar_0,...
    aggC_0,aggCstar_0,aggL_0,aggLstar_0,g_0,gstar_0,aggU_0,aggUstar_0]...
    =getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,...
    pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,...
    muh,muf,muhstar,mufstar,delta_muin,delta_nuin);


muh_0 = zeros(HH,1);
muf_0 = zeros(HH,1);
muhstar_0 = zeros(HH,1);
mufstar_0 = zeros(HH,1);

spending_0 = (chs_0.*S_0+chi_0.*I_0+chr_0.*R_0)./(cfs_0.*S_0+cfi_0.*I_0+cfr_0.*R_0);
spendingstar_0 = (cfsstar_0.*Sstar_0+cfistar_0.*Istar_0+cfrstar_0.*Rstar_0)./(chsstar_0.*Sstar_0+chistar_0.*Istar_0+chrstar_0.*Rstar_0);
h_0 = (chs_0.*S_0+chi_0.*I_0+chr_0.*R_0)/(crss*deltaHss/(deltaHss+deltaFss));
m_0 = (cfs_0.*S_0+cfi_0.*I_0+cfr_0.*R_0)/(crss*deltaFss/(deltaHss+deltaFss));
hstar_0 = (cfsstar_0.*Sstar_0+cfistar_0.*Istar_0+cfrstar_0.*Rstar_0)/(crss*deltaHss/(deltaHss+deltaFss));
mstar_0 = (chsstar_0.*Sstar_0+chistar_0.*Istar_0+chrstar_0.*Rstar_0)/(crss*deltaFss/(deltaHss+deltaFss));


ur_0=log(xr_0)-kappa/2*lr_0.^2;
urstar_0=log(xrstar_0)-kappa/2*lrstar_0.^2;
ui_0=log(xi_0)-kappa/2*li_0.^2;
uistar_0=log(xistar_0)-kappa/2*listar_0.^2;
us_0=log(xs_0)-kappa/2*ls_0.^2;
usstar_0=log(xsstar_0)-kappa/2*lsstar_0.^2;
aggu_0=S_0.*us_0 + I_0.*ui_0 + R_0.*ur_0;
aggustar_0=Sstar_0.*usstar_0 + Istar_0.*uistar_0 + Rstar_0.*urstar_0;

us_0=log(xs_0)-kappa/2*ls_0.^2;
ui_0=log(xi_0)-kappa/2*li_0.^2;
ur_0=log(xr_0)-kappa/2*lr_0.^2;
welfare_0 = us_0.*S_0+ui_0.*I_0+ur_0.*R_0;
welfare_cure0 = urss*(S_0+I_0+R_0);

usstar_0=log(xsstar_0)-kappa/2*lsstar_0.^2;
uistar_0=log(xistar_0)-kappa/2*listar_0.^2;
urstar_0=log(xrstar_0)-kappa/2*lrstar_0.^2;
welfarestar_0 = usstar_0.*Sstar_0+uistar_0.*Istar_0+urstar_0.*Rstar_0;
welfare_curestar0 = urss*(Sstar_0+Istar_0+Rstar_0);

sum(welfare_0.*(beta.^(0:HH-1))') + (S_0(HH)+I_0(HH)+R_0(HH)).*Urss*beta^HH - aggU_0
sum(welfarestar_0.*(beta.^(0:HH-1))') + (Sstar_0(HH)+Istar_0(HH)+Rstar_0(HH)).*Urss*beta^HH - aggUstar_0


W_0 = [sum((welfare_0-welfare_cure0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-S_0-I_0-R_0)).*(beta.^(0:HH-1))') - (1-S_0(HH)-I_0(HH)-R_0(HH)).*Urss*beta^HH,...
sum((welfarestar_0-welfare_curestar0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-Sstar_0-Istar_0-Rstar_0)).*(beta.^(0:HH-1))') - (1-Sstar_0(HH)-Istar_0(HH)-Rstar_0(HH)).*Urss*beta^HH];





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% social planner
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(file_sp);

[n_vec,fval,exitflag]=fsolve(@getErr,n_vec,opts_fsolve,...
    HH,policylength,beta,z,zstar,kappa,...
    alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
    pi2,pi3,pi4,pir,pid,pid_accel,phi,...
    Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

[err_sp,ls_sp,lsstar_sp,li_sp,listar_sp,lr_sp,lrstar_sp,xs_sp,xsstar_sp,...
    xi_sp,xistar_sp,xr_sp,xrstar_sp,chs_sp,cfs_sp,chsstar_sp,cfsstar_sp,...
    chi_sp,cfi_sp,chistar_sp,cfistar_sp,chr_sp,cfr_sp,chrstar_sp,cfrstar_sp,...
    ph_sp,pfstar_sp,S_sp,Sstar_sp,I_sp,Istar_sp,R_sp,Rstar_sp,T_sp,Tstar_sp,...
    aggC_sp,aggCstar_sp,aggL_sp,aggLstar_sp,g_sp,gstar_sp,aggU_sp,aggUstar_sp]...
    =getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,...
    pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,...
    muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

muh_sp = muh;
muf_sp = muf;
muhstar_sp = muhstar;
mufstar_sp = mufstar;

spending_sp = (chs_sp.*S_sp+chi_sp.*I_sp+chr_sp.*R_sp)./(cfs_sp.*S_sp+cfi_sp.*I_sp+cfr_sp.*R_sp);
spendingstar_sp = (cfsstar_sp.*Sstar_sp+cfistar_sp.*Istar_sp+cfrstar_sp.*Rstar_sp)./(chsstar_sp.*Sstar_sp+chistar_sp.*Istar_sp+chrstar_sp.*Rstar_sp);
h_sp = (chs_sp.*S_sp+chi_sp.*I_sp+chr_sp.*R_sp)/(crss*deltaHss/(deltaHss+deltaFss));
m_sp = (cfs_sp.*S_sp+cfi_sp.*I_sp+cfr_sp.*R_sp)/(crss*deltaFss/(deltaHss+deltaFss));
hstar_sp = (cfsstar_sp.*Sstar_sp+cfistar_sp.*Istar_sp+cfrstar_sp.*Rstar_sp)/(crss*deltaHss/(deltaHss+deltaFss));
mstar_sp = (chsstar_sp.*Sstar_sp+chistar_sp.*Istar_sp+chrstar_sp.*Rstar_sp)/(crss*deltaFss/(deltaHss+deltaFss));

ur_sp=log(xr_sp)-kappa/2*lr_sp.^2;
urstar_sp=log(xrstar_sp)-kappa/2*lrstar_sp.^2;
ui_sp=log(xi_sp)-kappa/2*li_sp.^2;
uistar_sp=log(xistar_sp)-kappa/2*listar_sp.^2;
us_sp=log(xs_sp)-kappa/2*ls_sp.^2;
usstar_sp=log(xsstar_sp)-kappa/2*lsstar_sp.^2;
aggu_sp=S_sp.*us_sp + I_sp.*ui_sp + R_sp.*ur_sp;
aggustar_sp=Sstar_sp.*usstar_sp + Istar_sp.*uistar_sp + Rstar_sp.*urstar_sp;


us_sp=log(xs_sp)-kappa/2*ls_sp.^2;
ui_sp=log(xi_sp)-kappa/2*li_sp.^2;
ur_sp=log(xr_sp)-kappa/2*lr_sp.^2;
welfare_sp = us_sp.*S_sp+ui_sp.*I_sp+ur_sp.*R_sp;
welfare_cure0 = urss*(S_sp+I_sp+R_sp);

usstar_sp=log(xsstar_sp)-kappa/2*lsstar_sp.^2;
uistar_sp=log(xistar_sp)-kappa/2*listar_sp.^2;
urstar_sp=log(xrstar_sp)-kappa/2*lrstar_sp.^2;
welfarestar_sp = usstar_sp.*Sstar_sp+uistar_sp.*Istar_sp+urstar_sp.*Rstar_sp;
welfare_curestar0 = urss*(Sstar_sp+Istar_sp+Rstar_sp);

sum(welfare_sp.*(beta.^(0:HH-1))') + (S_sp(HH)+I_sp(HH)+R_sp(HH)).*Urss*beta^HH - aggU_sp
sum(welfarestar_sp.*(beta.^(0:HH-1))') + (Sstar_sp(HH)+Istar_sp(HH)+Rstar_sp(HH)).*Urss*beta^HH - aggUstar_sp



W_sp = [sum((welfare_sp-welfare_cure0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-S_sp-I_sp-R_sp)).*(beta.^(0:HH-1))') - (1-S_sp(HH)-I_sp(HH)-R_sp(HH)).*Urss*beta^HH,...
sum((welfarestar_sp-welfare_curestar0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-Sstar_sp-Istar_sp-Rstar_sp)).*(beta.^(0:HH-1))') - (1-Sstar_sp(HH)-Istar_sp(HH)-Rstar_sp(HH)).*Urss*beta^HH];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% nash
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(file_nash);



[n_vec,fval,exitflag]=fsolve(@getErr,n_vec,opts_fsolve,...
    HH,policylength,beta,z,zstar,kappa,...
    alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
    pi2,pi3,pi4,pir,pid,pid_accel,phi,...
    Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);


[err_nash,ls_nash,lsstar_nash,li_nash,listar_nash,lr_nash,lrstar_nash,xs_nash,xsstar_nash,...
    xi_nash,xistar_nash,xr_nash,xrstar_nash,chs_nash,cfs_nash,chsstar_nash,cfsstar_nash,...
    chi_nash,cfi_nash,chistar_nash,cfistar_nash,chr_nash,cfr_nash,chrstar_nash,cfrstar_nash,...
    ph_nash,pfstar_nash,S_nash,Sstar_nash,I_nash,Istar_nash,R_nash,Rstar_nash,T_nash,Tstar_nash,...
    aggC_nash,aggCstar_nash,aggL_nash,aggLstar_nash,g_nash,gstar_nash,aggU_nash,aggUstar_nash]...
    =getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,...
    pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,...
    muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

muh_nash = muh;
muf_nash = muf;
muhstar_nash = muhstar;
mufstar_nash = mufstar;


spending_nash = (chs_nash.*S_nash+chi_nash.*I_nash+chr_nash.*R_nash)./(cfs_nash.*S_nash+cfi_nash.*I_nash+cfr_nash.*R_nash);
spendingstar_nash = (cfsstar_nash.*Sstar_nash+cfistar_nash.*Istar_nash+cfrstar_nash.*Rstar_nash)./(chsstar_nash.*Sstar_nash+chistar_nash.*Istar_nash+chrstar_nash.*Rstar_nash);
h_nash = (chs_nash.*S_nash+chi_nash.*I_nash+chr_nash.*R_nash)/(crss*deltaHss/(deltaHss+deltaFss));
m_nash = (cfs_nash.*S_nash+cfi_nash.*I_nash+cfr_nash.*R_nash)/(crss*deltaFss/(deltaHss+deltaFss));
hstar_nash = (cfsstar_nash.*Sstar_nash+cfistar_nash.*Istar_nash+cfrstar_nash.*Rstar_nash)/(crss*deltaHss/(deltaHss+deltaFss));
mstar_nash = (chsstar_nash.*Sstar_nash+chistar_nash.*Istar_nash+chrstar_nash.*Rstar_nash)/(crss*deltaFss/(deltaHss+deltaFss));

ur_nash=log(xr_nash)-kappa/2*lr_nash.^2;
urstar_nash=log(xrstar_nash)-kappa/2*lrstar_nash.^2;
ui_nash=log(xi_nash)-kappa/2*li_nash.^2;
uistar_nash=log(xistar_nash)-kappa/2*listar_nash.^2;
us_nash=log(xs_nash)-kappa/2*ls_nash.^2;
usstar_nash=log(xsstar_nash)-kappa/2*lsstar_nash.^2;
aggu_nash=S_nash.*us_nash + I_nash.*ui_nash + R_nash.*ur_nash;
aggustar_nash=Sstar_nash.*usstar_nash + Istar_nash.*uistar_nash + Rstar_nash.*urstar_nash;


us_nash=log(xs_nash)-kappa/2*ls_nash.^2;
ui_nash=log(xi_nash)-kappa/2*li_nash.^2;
ur_nash=log(xr_nash)-kappa/2*lr_nash.^2;
welfare_nash = us_nash.*S_nash+ui_nash.*I_nash+ur_nash.*R_nash;
welfare_cure0 = urss1*(S_nash+I_nash+R_nash);

usstar_nash=log(xsstar_nash)-kappa/2*lsstar_nash.^2;
uistar_nash=log(xistar_nash)-kappa/2*listar_nash.^2;
urstar_nash=log(xrstar_nash)-kappa/2*lrstar_nash.^2;
welfarestar_nash = usstar_nash.*Sstar_nash+uistar_nash.*Istar_nash+urstar_nash.*Rstar_nash;
welfare_curestar0 = urss1*(Sstar_nash+Istar_nash+Rstar_nash);

sum(welfare_nash.*(beta.^(0:HH-1))') + (S_nash(HH)+I_nash(HH)+R_nash(HH)).*Urss*beta^HH - aggU_nash
sum(welfarestar_nash.*(beta.^(0:HH-1))') + (Sstar_nash(HH)+Istar_nash(HH)+Rstar_nash(HH)).*Urss*beta^HH - aggUstar_nash


Urss_tradewar=1/(1-beta)*urss1;
Urss0=1/(1-beta)*urss; 


W_nash = [sum((welfare_nash-welfare_cure0).*(beta.^(0:HH-1))'),...
-sum((urss1*(1-S_nash-I_nash-R_nash)).*(beta.^(0:HH-1))') - (1-S_nash(HH)-I_nash(HH)-R_nash(HH)).*Urss_tradewar*beta^HH,...
sum((welfarestar_nash-welfare_curestar0).*(beta.^(0:HH-1))'),...
-sum((urss1*(1-Sstar_nash-Istar_nash-Rstar_nash)).*(beta.^(0:HH-1))') - (1-Sstar_nash(HH)-Istar_nash(HH)-Rstar_nash(HH)).*Urss_tradewar*beta^HH];


['Country A Util: ', num2str(aggU_0 - Urss), ',',...
    num2str(aggU_nash - Urss), ',', num2str(aggU_sp - Urss)]
['Country B Util: ', num2str(aggUstar_0 - Urss), ',',...
    num2str(aggUstar_nash - Urss), ',', num2str(aggUstar_sp - Urss)]
['Total Util: ', num2str(aggU_0+aggUstar_0 - Urss*2), ',',...
    num2str(aggU_nash+aggUstar_nash - Urss*2), ',', num2str(aggU_sp+aggUstar_sp - Urss*2)]

W=[W_0; W_nash; W_sp];
W = [W(:,1)+W(:,2),W(:,1:2),W(:,3)+W(:,4),W(:,3:4)];
W = [W; W(3,:)-W(2,:)];




% for text
[tmp1, tmp2] = max(I_0)
[tmp1, tmp2] = max(Istar_0)
[tmp1, tmp2] = max(1-S_0)
[tmp1, tmp2] = max(1-Sstar_0)
[tmp1, tmp2] = max(1-S_0-I_0-R_0)
[tmp1, tmp2] = max(ph_0./pfstar_0)

[tmp1, tmp2] = max(I_sp)
[tmp1, tmp2] = max(Istar_sp)
[tmp1, tmp2] = max(1-S_sp)
[tmp1, tmp2] = max(1-S_sp-I_sp-R_sp)
[tmp1, tmp2] = max(muf_sp-muh_sp)
[tmp1, tmp2] = min(muhstar_sp-mufstar_sp)
[tmp1, tmp2] = max(ph_sp./pfstar_sp)



[tmp1, tmp2] = max(I_nash)
[tmp1, tmp2] = max(Istar_nash)
[tmp1, tmp2] = max(muh_nash)
[tmp1, tmp2] = max(muhstar_nash-mufstar_nash)
[tmp1, tmp2] = max(muf_nash-muh_nash)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


ia=3;ib=4;fsize=12;
horz=HH;
time=0:1:horz-1;


f=figure;
subplot(ia,ib,1)
plot(time,S_0(1:horz),time,Sstar_0(1:horz),'LineWidth',2);
box off;
title('Susceptibles $S$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
legend('Country A', 'Country B', 'Location', 'northeast');

subplot(ia,ib,2)
plot(time,I_0(1:horz),time,Istar_0(1:horz),'LineWidth',2);
box off;
title('Infected $I$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,3)
plot(time,R_0(1:horz),time,Rstar_0(1:horz),'LineWidth',2);
box off;
title('Recovered $R$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,4)
h = plot(time,1-S_0(1:horz)-I_0(1:horz)-R_0(1:horz),...
    time,1-Sstar_0(1:horz)-Istar_0(1:horz)-Rstar_0(1:horz),'LineWidth',2);
box off;
title('Death $D$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h, 'axes');
ax{1}.YAxis.Exponent = 0;



subplot(ia,ib,5)
plot(time,muh_0(1:horz),time,mufstar_0(1:horz),'LineWidth',2);
box off;
title('Containment Tax $\mu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,0.8]);


subplot(ia,ib,6)
plot(time,muf_0(1:horz) - muh_0(1:horz),time,...
    muhstar_0(1:horz) - mufstar_0(1:horz),'LineWidth',2);
box off;
title('Tariff $\nu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);



subplot(ia,ib,7)
plot(time,muf_0(1:horz),time,...
    muhstar_0(1:horz),'LineWidth',2);
box off;
title('$\mu+\nu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,8)
plot(time,ph_0(1:horz)./pfstar_0(1:horz),'LineWidth',2);
box off;
title('Terms of Trade $p^A/p^B$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,9)
plot(time,aggL_0(1:horz),time,aggLstar_0(1:horz),'LineWidth',2);
box off;
title('Aggregate Labor $L$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([15,30]);

subplot(ia,ib,10)
plot(time,aggC_0(1:horz),time,aggCstar_0(1:horz),'LineWidth',2);
box off;
title('Aggregate Cons. $X$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

% subplot(ia,ib,11)
% plot(time,h_0(1:horz),time,m_0(1:horz),'LineWidth',2);
% box off;
% title('Country A Consumption','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% legend('Domestic H', 'Import M', 'Location', 'southeast');
% 
% subplot(ia,ib,12)
% plot(time,hstar_0(1:horz),time,mstar_0(1:horz),'LineWidth',2);
% box off;
% title('Country B Consumption','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% % legend('Domestic H', 'Import M', 'Location', 'southeast');

orient landscape

f.PaperSize = [8 6]*1.5;
print(['../Figures/',spec_label,'_Benchmark.pdf'],'-dpdf','-fillpage');

% plot(time,(chsstar_0.*Sstar_0+chistar_0.*Istar_0+chrstar_0.*Rstar_0),...
%     time,(cfs_0.*S_0+cfi_0.*I_0+cfr_0.*R_0),'LineWidth',2);
% box off;
% title('Exports','FontSize',fsize,'Interpreter','latex');
% % ylabel('Share of Initial Population','FontSize',fsize);
% set(gca,'FontSize',fsize);
% xlim([0,horz]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


ia=3;ib=4;fsize=12;
horz=HH;
time=0:1:horz-1;


f=figure;
subplot(ia,ib,1)
plot(time,S_sp(1:horz),time,Sstar_sp(1:horz),'LineWidth',2);
box off;
title('Susceptibles $S$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
legend('Country A', 'Country B', 'Location', 'northeast');

subplot(ia,ib,2)
plot(time,I_sp(1:horz),time,Istar_sp(1:horz),'LineWidth',2);
box off;
title('Infected $I$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,3)
plot(time,R_sp(1:horz),time,Rstar_sp(1:horz),'LineWidth',2);
box off;
title('Recovered $R$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,4)
h = plot(time,1-S_sp(1:horz)-I_sp(1:horz)-R_sp(1:horz),...
    time,1-Sstar_sp(1:horz)-Istar_sp(1:horz)-Rstar_sp(1:horz),'LineWidth',2);
box off;
title('Death $D$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h, 'axes');
ax{1}.YAxis.Exponent = 0;



subplot(ia,ib,5)
plot(time,muh_sp(1:horz),time,mufstar_sp(1:horz),'LineWidth',2);
box off;
title('Containment Tax $\mu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,0.8]);


subplot(ia,ib,6)
plot(time,muf_sp(1:horz) - muh_sp(1:horz),time,...
    muhstar_sp(1:horz) - mufstar_sp(1:horz),'LineWidth',2);
box off;
title('Tariff $\nu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,7)
plot(time,muf_sp(1:horz),time,...
    muhstar_sp(1:horz),'LineWidth',2);
box off;
title('$\mu+\nu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,8)
plot(time,ph_sp(1:horz)./pfstar_sp(1:horz),'LineWidth',2);
box off;
title('Terms of Trade $p^A/p^B$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,9)
plot(time,aggL_sp(1:horz),time,aggLstar_sp(1:horz),'LineWidth',2);
box off;
title('Aggregate Labor $L$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([15,30]);

subplot(ia,ib,10)
plot(time,aggC_sp(1:horz),time,aggCstar_sp(1:horz),'LineWidth',2);
box off;
title('Aggregate Cons. $X$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

% subplot(ia,ib,11)
% plot(time,h_sp(1:horz),time,m_sp(1:horz),'LineWidth',2);
% box off;
% title('Country A Consumption','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% legend('Domestic H', 'Import M', 'Location', 'southeast');
% 
% subplot(ia,ib,12)
% plot(time,hstar_sp(1:horz),time,mstar_sp(1:horz),'LineWidth',2);
% box off;
% title('Country B Consumption','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% % legend('Domestic H', 'Import M', 'Location', 'southeast');

orient landscape

f.PaperSize = [8 6]*1.5;
print(['../Figures/',spec_label,'_Planner.pdf'],'-dpdf','-fillpage');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ia=3;ib=4;fsize=12;
horz=HH;
time=0:1:horz-1;


f=figure;
subplot(ia,ib,1)
plot(time,S_nash(1:horz),time,Sstar_nash(1:horz),'LineWidth',2);
box off;
title('Susceptibles $S$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
legend('Country A', 'Country B', 'Location', 'northeast');

subplot(ia,ib,2)
plot(time,I_nash(1:horz),time,Istar_nash(1:horz),'LineWidth',2);
box off;
title('Infected $I$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,3)
plot(time,R_nash(1:horz),time,Rstar_nash(1:horz),'LineWidth',2);
box off;
title('Recovered $R$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,4)
h = plot(time,1-S_nash(1:horz)-I_nash(1:horz)-R_nash(1:horz),...
    time,1-Sstar_nash(1:horz)-Istar_nash(1:horz)-Rstar_nash(1:horz),'LineWidth',2);
box off;
title('Death $D$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h, 'axes');
ax{1}.YAxis.Exponent = 0;



subplot(ia,ib,5)
plot(time,muh_nash(1:horz),time,mufstar_nash(1:horz),'LineWidth',2);
box off;
title('Containment Tax $\mu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,0.8]);


subplot(ia,ib,6)
plot(time,muf_nash(1:horz) - muh_nash(1:horz),time,...
    muhstar_nash(1:horz) - mufstar_nash(1:horz),'LineWidth',2);
box off;
title('Tariff $\nu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,7)
plot(time,muf_nash(1:horz),time,...
    muhstar_nash(1:horz),'LineWidth',2);
box off;
title('$\mu+\nu$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,8)
plot(time,ph_nash(1:horz)./pfstar_nash(1:horz),'LineWidth',2);
box off;
title('Terms of Trade $p^A/p^B$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,9)
plot(time,aggL_nash(1:horz),time,aggLstar_nash(1:horz),'LineWidth',2);
box off;
title('Aggregate Labor $L$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([15,30]);

subplot(ia,ib,10)
plot(time,aggC_nash(1:horz),time,aggCstar_nash(1:horz),'LineWidth',2);
box off;
title('Aggregate Cons. $X$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

% subplot(ia,ib,11)
% plot(time,h_nash(1:horz),time,m_nash(1:horz),'LineWidth',2);
% box off;
% title('Country A Consumption','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% legend('Domestic H', 'Import M', 'Location', 'southeast');
% 
% subplot(ia,ib,12)
% plot(time,hstar_nash(1:horz),time,mstar_nash(1:horz),'LineWidth',2);
% box off;
% title('Country B Consumption','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% % legend('Domestic H', 'Import M', 'Location', 'southeast');

orient landscape

f.PaperSize = [8 6]*1.5;
print(['../Figures/',spec_label,'_Nash.pdf'],'-dpdf','-fillpage');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


ia=3;ib=4;fsize=12;
horz=HH;
time=0:1:horz-1;


f=figure;

subplot(ia,ib,1)
plot(time,I_0(1:horz),time,I_nash(1:horz),time,I_sp(1:horz),'LineWidth',2);
box off;
title('Country A Infected $I^A$','FontSize',fsize,'Interpreter','latex');
legend('No Policy', 'Nash', 'Planner','Location', 'northeast')
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,2)
h = plot(time,1-S_0(1:horz)-I_0(1:horz)-R_0(1:horz),...
    time,1-S_nash(1:horz)-I_nash(1:horz)-R_nash(1:horz),...
    time,1-S_sp(1:horz)-I_sp(1:horz)-R_sp(1:horz),'LineWidth',2);
box off;
title('Country A Death $D^A$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h, 'axes');
ax{1}.YAxis.Exponent = 0;

subplot(ia,ib,3)
plot(time,Istar_0(1:horz),time,Istar_nash(1:horz),time,Istar_sp(1:horz),'LineWidth',2);
box off;
title('Country B Infected $I^B$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,4)
h = plot(time,1-Sstar_0(1:horz)-Istar_0(1:horz)-Rstar_0(1:horz),...
    time,1-Sstar_nash(1:horz)-Istar_nash(1:horz)-Rstar_nash(1:horz),...
    time,1-Sstar_sp(1:horz)-Istar_sp(1:horz)-Rstar_sp(1:horz),'LineWidth',2);
box off;
title('B Death $D^B$','FontSize',fsize,'Interpreter','latex');
% ylabel('Share of Initial Population','FontSize',fsize);
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ax = ancestor(h, 'axes');
ax{1}.YAxis.Exponent = 0;

subplot(ia,ib,5)
plot(time,muh_0(1:horz),time,muh_nash(1:horz),time,muh_sp(1:horz),'LineWidth',2);
box off;
title('Country A Containment Tax $\mu^A$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,0.8]);

subplot(ia,ib,6)
plot(time,muf_0(1:horz)-muh_0(1:horz),...
    time,muf_nash(1:horz)-muh_nash(1:horz),...
    time,muf_sp(1:horz)-muh_sp(1:horz),'LineWidth',2);
box off;
title('Country A Tariff $\nu^A$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,7)
plot(time,mufstar_0(1:horz),time,mufstar_nash(1:horz),time,mufstar_sp(1:horz),'LineWidth',2);
box off;
title('Country B Containment Tax $\mu^B$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([0,0.8]);

subplot(ia,ib,8)
plot(time,mufstar_0(1:horz)-muhstar_0(1:horz),...
    time,mufstar_nash(1:horz)-muhstar_nash(1:horz),...
    time,mufstar_sp(1:horz)-muhstar_sp(1:horz),'LineWidth',2);
box off;
title('Country B Tariff $\nu^B$','FontSize',fsize,'Interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,9)
plot(time,muf_0(1:horz),...
    time,muf_nash(1:horz),...
    time,muf_sp(1:horz),'LineWidth',2);
box off;
title('Country A $\mu^A+\nu^A$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,10)
plot(time,muhstar_0(1:horz),...
    time,muhstar_nash(1:horz),...
    time,muhstar_sp(1:horz),'LineWidth',2);
box off;
title('Country B $\mu^B+\nu^B$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,11)
plot(time,ph_0(1:horz)./pfstar_0(1:horz),...
    time,ph_nash(1:horz)./pfstar_nash(1:horz),...
    time,ph_sp(1:horz)./pfstar_sp(1:horz),'LineWidth',2);
box off;
title('Terms of Trade $p^A/p^B$','FontSize',fsize,'Interpreter','latex');
xlabel('Weeks','FontSize',fsize,'interpreter','latex');
set(gca,'FontSize',fsize);
xlim([0,horz]);

% subplot(ia,ib,10)
% plot(time,spending_0(1:horz),time,spending_nash(1:horz),time,spending_sp(1:horz),'LineWidth',2);
% box off;
% title('A Cons. Ratio $c^A_A/c^A_B$','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);
% 
% subplot(ia,ib,11)
% plot(time,spendingstar_0(1:horz),time,spendingstar_nash(1:horz),time,spendingstar_sp(1:horz),'LineWidth',2);
% box off;
% title('B Cons. Ratio $c^B_B/c^B_A$','FontSize',fsize,'Interpreter','latex');
% xlabel('Weeks','FontSize',fsize,'interpreter','latex');
% set(gca,'FontSize',fsize);
% xlim([0,horz]);

orient landscape

f.PaperSize = [8 6]*1.5;
print(['../Figures/',spec_label,'_Compare1.pdf'],'-dpdf','-fillpage');



close all;